{*************************************}
{ calcul statistique, avec des classes}
{*************************************}

unit UCalcStatObjet;

interface

USES
    {lien sur l'unit contenant la fiche principale}
    UFrmPrincipale;

TYPE
    {structure de tableau de donnes relles}
    TTabDataClasse = array of double;

    {structure de classe : fusionnant les donnes et les procdures les manipulant}
    TCCalcStat = class
                 {tableau de donnes interne}
                 tab: TTabDataClasse;
                 {rcuprer et tester les donnes de la fiche}
                 function recupValeurs(frm: TFrmStat): boolean;
                 {vider le tableau}
                 procedure viderTableau();
                 {calculer la moyenne  partir du tableau}
                 function  moyenne(): double;
                 {calculer la variance  partir du tableau}
                 function  variance(): double;
                 end;


implementation

USES
    Sysutils;

{ TCCalcStat }

function TCCalcStat.moyenne: double;
var n,i: integer;
    somme: double;
begin
 n:= Length(tab);
 if (n>0)
  then
   begin
    //somme
    somme:= 0;
    for i:= 0 to n-1 do
     somme:= somme+tab[i];
    //moyenne
    result:= somme/(1.0*n);
   end
  else result:= 0.0;
end;

function TCCalcStat.recupValeurs(frm: TFrmStat): boolean;
var ok: boolean;
    n,i: integer;
begin
 n:= frm.lstbValeurs.Items.Count;
 if (n>0)
  then
   begin
    TRY
     //donner la bonne taille
     SetLength(tab,n);
     //copier les donnes aprs transtypage
     for i:= 0 to n-1 do
      tab[i]:= StrToFloat(frm.lstbValeurs.Items.Strings[i]);
     //si tout s'est bien droul, c'est le seul cas o ok est  TRUE
     ok:= TRUE;
    EXCEPT
     ok:= FALSE;
    END;
   end
  else ok:= FALSE;
 //renvoyer
 result:= ok;
end;

function TCCalcStat.variance: double;
var n,i: integer;
    m,somme: double;
begin
 n:= length(tab);
 if (n>0)
  then
   begin
    m:= moyenne();
    somme:= 0.0;
    for i:= 0 to n-1 do
     somme:= somme+SQR(tab[i]-m);
    result:= somme/(1.0*n);
   end
  else result:= 0.0;
end;

procedure TCCalcStat.viderTableau;
begin
 SetLength(tab,0);
end;

end.
