unit UFrmPrincipale;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls;

type
  TFrmStat = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Nouveau1: TMenuItem;
    N1: TMenuItem;
    Ouvrir1: TMenuItem;
    Sauver1: TMenuItem;
    N2: TMenuItem;
    Quitter1: TMenuItem;
    Statistique1: TMenuItem;
    Moyennefonction1: TMenuItem;
    N3: TMenuItem;
    Moyenneobjet1: TMenuItem;
    Varianceobjet1: TMenuItem;
    N4: TMenuItem;
    Graphique1: TMenuItem;
    N5: TMenuItem;
    Rapport1: TMenuItem;
    Panel1: TPanel;
    lstbValeurs: TListBox;
    edValeur: TEdit;
    btnAjouter: TButton;
    btnVider: TButton;
    btnSupprimer: TButton;
    grbResultat: TGroupBox;
    lblEtiqStat: TLabel;
    lblValeurStat: TLabel;
    procedure Quitter1Click(Sender: TObject);
    procedure btnAjouterClick(Sender: TObject);
    procedure btnViderClick(Sender: TObject);
    procedure btnSupprimerClick(Sender: TObject);
    procedure Nouveau1Click(Sender: TObject);
    procedure Moyennefonction1Click(Sender: TObject);
    procedure Moyenneobjet1Click(Sender: TObject);
    procedure Varianceobjet1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure ecrireResultat(etiq: string; valeur: string);
  end;

var
  FrmStat: TFrmStat;

implementation

USES
    {lien sur l'unit de calcul des stats par des fonctions}
    UCalcStatFonction,
    {lien sur l'unit de calcul des stats par des classes}
    UCalcStatObjet;

{$R *.DFM}

procedure TFrmStat.Quitter1Click(Sender: TObject);
begin
 //fermer la fentre principale arrte l'excution de l'application
 Close();
end;

procedure TFrmStat.btnAjouterClick(Sender: TObject);
begin
 TRY
 //tester le transtypage
 StrToFloat(edValeur.Text);
 //ajout si pas de pbm
 lstbValeurs.Items.Add(edValeur.Text);
 EXCEPT
 //vider la zone d'dition si souci, sans ajouter
 edValeur.Text:= '';
 END;
end;

procedure TFrmStat.btnViderClick(Sender: TObject);
begin
 //vider la liste
 lstbValeurs.Items.Clear();
end;

procedure TFrmStat.btnSupprimerClick(Sender: TObject);
begin
 //supprimer l'lment slectionn... s'il existe
 if (lstbValeurs.ItemIndex>=0)
  then lstbValeurs.Items.Delete(lstbValeurs.ItemIndex);
end;

procedure TFrmStat.Nouveau1Click(Sender: TObject);
begin
 //appel du gestionnaire d'vnements du bouton vider
 btnViderClick(sender);
end;

procedure TFrmStat.Moyennefonction1Click(Sender: TObject);
var tab: TTabDataFonction;
begin
 //*******************************************//
 //*** calcul en passant par des fonctions ***//
 //*******************************************//
 
 //rcuprer les donnes dans un tableau de rels, TRUE si OK
 if (recupValeurs(tab,FrmStat) = TRUE)
  //affichage de la moyenne si ok
  then ecrireResultat('Moyenne',FloatToStr(moyenne(tab)))
  else ecrireResultat('Problme','donnes non valides');
 //vider le tableau avant de sortir de la procdure
 viderTableau(tab);
end;

procedure TFrmStat.ecrireResultat(etiq, valeur: string);
begin
 lblEtiqStat.Caption:= etiq+' :';
 lblValeurStat.Caption:= valeur;
end;

procedure TFrmStat.Moyenneobjet1Click(Sender: TObject);
var objStat: TCCalcStat;
begin
 //****************************************//
 //*** calcul en passant par des objets ***//
 //****************************************//

 //allouer l'objet
 objStat:= TCCalcStat.Create();

 //test des donnes
 if (objStat.recupValeurs(FrmStat) = true)
  //affichage de la moyenne si ok
  then ecrireResultat('Moyenne',FloatToStr(objStat.moyenne()))
  else ecrireResultat('Problme','donnes non valides');
 //vider le tableau
 objStat.viderTableau();

 //dsallouer l'objet
 objStat.Free();
end;

procedure TFrmStat.Varianceobjet1Click(Sender: TObject);
var objStat: TCCalcStat;
begin
 //****************************************//
 //*** calcul en passant par des objets ***//
 //****************************************//

 //allouer l'objet
 objStat:= TCCalcStat.Create();

 //test des donnes
 if (objStat.recupValeurs(FrmStat) = true)
  //affichage de la moyenne si ok
  then ecrireResultat('Variance',FloatToStr(objStat.variance()))
  else ecrireResultat('Problme','donnes non valides');
 //vider le tableau
 objStat.viderTableau();
 
 //dsallouer l'objet
 objStat.Free();
end;

end.
